<template>
  <div ref="el" :style="[styleStatic, styleCurrent]">
    <slot />
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType, ref, onMounted, computed } from "vue";
import { animationFrame } from "@/util/dom";

export default defineComponent({
  props: {
    start: {
      type: Object as PropType<Partial<CSSStyleDeclaration>>,
      default: null,
    },
    end: {
      type: Object as PropType<Partial<CSSStyleDeclaration>>,
      default: null,
    },
  },
  emits: ["finish"],
  setup(props, { emit }) {
    const styleStatic = computed<Partial<CSSStyleDeclaration>>(() => ({
      position: "absolute",
      transition: "all 350ms ease",
    }));
    // todo make reactive and observe changes

    const el = ref<HTMLElement>();
    const styleCurrent = ref<Partial<CSSStyleDeclaration>>(props.start);

    onMounted(async () => {
      await animationFrame();
      styleCurrent.value = props.end;
      el.value!.addEventListener("transitionend", () => emit("finish"), {
        once: true,
      });
    });

    return {
      el,
      styleStatic,
      styleCurrent,
    };
  },
});
</script>
